<html>
  <link rel="stylesheet" href="http://www.cis.gvsu.edu/~dulimarh/styles/handout.css">
  <style>
    .hilite {
      color: red;
    }
  </style>
  <body>
    <h1>Virtual Sea Port</h1>

    <blockquote>
      The idea of this project began as my conversation with Dr. Anton Fenik 
      (Marketing Department, Seidman College of Business), who is applying
      for a research funding to build a teaching tool for his supply chain management
      class.
    </blockquote>
    <h2>Objectives</h2>
    <ol>
      <li>Incorporate motion sensors on mobile devices for controlling 3D graphics</li>
      <li>Incorporate WebVR control into a 3D graphics application</li>
      <li>Build a 3D graphics application suitable for viewing using browsers on mobile devices</li>
    </ol>
    <h2>Project Overview</h2>
    <p>Look for ideas from objects and equipments typically found in a commercial sea port:
      cranes, ships, semi trucks, containers, street lights, tugboats, loading docks,
      warehouse, office buildings, etc.
    </p>

    <p>The following video may provide more inspiration in designing your graphics objects</p>
    <div style="text-align: center">
    <iframe width="560" height="315" src="https://www.youtube.com/embed/ZX_TROeJiuk" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
  </div>
    <p>The main goal of this project is to build a <i>semi-realistic</i> scene of seaport with moving objects.
    Hence, some elements of animations (either autonomous or controlled) must be included
    in your project</p>.
    <h2>Minimum Requirements</h2>
    <ol>
      <li>Build 3D objects that have moving parts and inspired by typical objects found
        at a <b>commercial sea port</b> .</li>
        <li>Include a WebVR library to control your camera</li>
        <li>Design your program such that some of these objects demonstrate perpetual animations,
        i.e animations which do not require user control.
      </li>
      <li>Allow user interactions to control the animation of some objects. Use any interactions
        mechanisms you prefer, <b>but the keyboard</b>. Recall that you graphics will be mostly viewed on a 
        mobile device, using keypresses to control your animation would be awkward.
      </li>
      <li>Include textures ("lots" of them) and light sources to create almost realistic appearance of your 
        graphics.
      Experiment with both point lights and directional lights</li>
    </ol>
    <h2>WebVR Overview</h2>
    <p>A decade ago Virtual Reality (VR) requires costly equipments which are not affordable to most college students.
      Today, you can build your own VR application using a smartphone.
      Moreover, you don't have to write any mobile apps to build a VR application,
      <a href="http://webvr.info">WebVR</a>, a new Web standard published in December 2017, allows you to write
      a VR application that runs on (mobile) browsers.
    </p>
    <p>You have learned how to interact with your graphics using convential
      means (keyboard, mouse, buttons). In a VR application, the user controls
      the graphics usually using a head mounted display (HMD). Essentially, the
      HMD is equipped with sensors that monitor the head motions.
      To use the output from these sensors, your program must provide motion/orientation listener,
      and use the data for controlling your graphics. In a JavaScript program, it boils down to
      writing a '<code>deviceorientation</code>' event listener to monitor
      your device rotation angles:
    </p>
    <pre class="cppcode">
window.addEventListener ('deviceorientation', event => {
  // Use event.alpha, event.beta, event.gamma to update camera matrix  
})      
    </pre>
    <p>Details about these three angles can be found in the <a 
    href="https://w3c.github.io/deviceorientation/spec-source-orientation.html">W3C Specification Document</a>.</p>

    <p>Fortunately, you don't have to implement this camera update logic yourself;
      there is a companion ThreeJS modules </code><code>three-vrcontrols-module</code>
    designed specifically for this purpose. Be sure to include it as another dependency of your app:</p>
    <pre class="unixcmd">
# Version 2.1.0      
yarn add three-vrcontrols-module
    </pre>
    <p>As an extra benefit, the library also applies post processing to the raw sensor data and
      fuse it with other sources to provide cleaned-up and more accurate readings to your program.</p>
    <p>Since WebVR is a new technology, mobile browsers support may vary. Your graphics program may work
      on certain browsers, but not the others. To avoid this problem, you can also include another
      polyfill library:
      <pre class="unixcmd">
# Version 0.10.5      
yarn add webvr-polyfill
      </pre>
    </p>

    <p>Although yor app is designed mostly for mobile browsers, you should
      allow non-mobile users to launch your app without a virtual environment.
      In which case, typical touch controls should be supported either using orbit control
      or trackball control:
      <pre class="unixcmd">
# Choose one of the following
yarn add three-oribit-controls
yarn add three-trackballcontrols
      </pre>
              </p>
    <p>Once these libraries are in place, the skeleton of your program would Look
      like the following snippet
    </p>
<pre class="cppcode">
import { WebGLRenderer, PerspectiveCamera, Scene } from 'three';
<b class="hilite">import VRControls from 'three-vrcontrols-module';</b>
<b class="hilite">import WebVRPolyfill from 'webvr-polyfill';</b>
import TrackballControls from 'three-trackballcontrols';

const renderer = new WebGLRenderer(____);
const camera = new PerspectiveCamera(____);
const scene = new Scene();
scene.add(camera);
var display, camControl;

//--- More code here as necessary ---//

<b class="hilite">const polyfill = new WebVRPolyfill();</b>
navigator.getVRDisplays().then(displays => {
  if (displays.length > 0) {
    // WebVR is supported
    display = displays[0];
    camControl = <b class="hilite">new VRControls(camera);</b>
  } else {
    // WebVR is NOT supported, fallback to trackball control
    display = window;
    camControl = new TrackballControls(camera);
  }
  display.requestAnimationFrame(render);
});

//--- More code here as necessary ---//

function render() {
  renderer.render(scene, camera);
  camControl.update();
  display.requestAnimationFrame(render);
}
</pre>
<p>The rest of your code would be similar to a non-VR graphics program</p>
    <h2>Sample Program</h2>
    <p>Scan the following QR code on your mobile phone to see a sample program that 
      incorporates WebVR controls:
    </p>
    <img src="webvr-sample-qrcode.png">

<h2>Development Tools: Browser Extensions</h2>
<p>If you prefer test your VR program without using a mobile phone during development, you
  may want to install the <a href="https://chrome.google.com/webstore/detail/webvr-api-emulation/gbdnpaebafagioggnhkacnaaahpiefil">WebVR API Emulation</a>
  extension for Chrome.
</p>
<div style="text-align:center">
<img src="WebVR_Emulation.png" width="600">
</div>
<p>When you open the <b>Developer Tools</b>, you will find a new tab "WebVR" that lets you control 
  the orientation of your "mobile device".</p>

<h2>Grading and Due Date</h2>
<p>I consider this project an extra credit. You may complete this individually or with a partner and 
  turn in the final product on the exam day (Thursday, Apr 26).
  <ul>
    <li>More features you put in, more points you will earn</li>
    <li>More aesthetic you design the graphics, more points you will earn</li>
    <li>More realistic the graphics, more points you will earn</li>
    <li>Also, presenting your project at the PCEC Engineering Project day earns extra point.
      Last day of <a href="https://docs.google.com/forms/d/18XWgvB-45GeKhodOZETeWtFcTap1ltBni3JAnlXsZes/edit?usp=sharing">registration</a> 
      is April 13.
    </li>
  </ul>
</p>
<p>I let you "compete" with your classmates to earn as many points as possible. I plan to assign the final grades
  after ranking your projects based on the overall quality.
</p>
<p>At the end of the semester, I will show few selected projects to Dr. Fenik. There is a chance that you 
  may be recruited to work on this research project.
</p>
</body>
</html>